#include "main.h"
//------------------------------------------------------
xQueueHandle xQueue;
typedef struct
{
  unsigned char num_task;
  unsigned long cnt;
} qData;
typedef struct
{
  unsigned char num_task;
  unsigned short del;
} pData;
pData dt1, dt2, dt3, dt4;
//------------------------------------------------------
void ICACHE_FLASH_ATTR vRecvTask(void *pvParameters)
{
  portBASE_TYPE xStatus;
  char str01[20];
  qData xReceivedData;
  while(1)
  {
    if (uxQueueMessagesWaiting(xQueue) != 0)
    {
      os_printf("Queue should have been empty!\n");
    }
    xStatus = xQueueReceive(xQueue, &xReceivedData, 10000 /portTICK_RATE_MS);
    if (xStatus == pdPASS)
    {
      snprintf(str01, sizeof(str01), "%7lu", xReceivedData.cnt);
      LCD_SetPos(7,xReceivedData.num_task - 1);
      LCD_String(str01);
    }
    else
    {
      os_printf("Could not receive from the queue.\n");
    }
  }
}
//------------------------------------------------------
void ICACHE_FLASH_ATTR task1(void *pvParameters)
{
  qData xReceivedData;
  pData *pdt = (pData*) pvParameters;
  xReceivedData.cnt = 0;
  xReceivedData.num_task = pdt->num_task;
  portBASE_TYPE xStatus;
  while(1)
  {
    xStatus = xQueueSendToBack(xQueue, &xReceivedData, 0);
    if (xStatus != pdPASS)
    {
      os_printf("Could not send to the queue.\n");
    }
    xReceivedData.cnt++;
    if(xReceivedData.cnt>=10000000) xReceivedData.cnt=0;
    vTaskDelay(pdt->del / portTICK_RATE_MS);
  }
}
//------------------------------------------------------
uint32 user_rf_cal_sector_set(void)
{
    flash_size_map size_map = system_get_flash_size_map();
    uint32 rf_cal_sec = 0;

    switch (size_map) {
        case FLASH_SIZE_4M_MAP_256_256:
            rf_cal_sec = 128 - 5;
            break;

        case FLASH_SIZE_8M_MAP_512_512:
            rf_cal_sec = 256 - 5;
            break;

        case FLASH_SIZE_16M_MAP_512_512:
        case FLASH_SIZE_16M_MAP_1024_1024:
            rf_cal_sec = 512 - 5;
            break;

        case FLASH_SIZE_32M_MAP_512_512:
        case FLASH_SIZE_32M_MAP_1024_1024:
            rf_cal_sec = 1024 - 5;
            break;

        default:
            rf_cal_sec = 0;
            break;
    }
    return rf_cal_sec;
}
//------------------------------------------------------
void ICACHE_FLASH_ATTR user_init()
{
  UART_SetBaudrate(UART0,BIT_RATE_115200);
  UART_SetBaudrate(UART1,BIT_RATE_115200);
  os_printf("\r\n\r\n");
  os_printf("SDK version:%s\n", system_get_sdk_version());
  os_printf("\r\n\r\n");
  i2c_mas_gpio_init();
  I2C_MASTER_SDA_LOW_SCL_LOW();
  LCD_ini();
  LCD_SetPos(0,0);
  LCD_String("Task1:");
  LCD_SetPos(0,1);
  LCD_String("Task2:");
  LCD_SetPos(0,2);
  LCD_String("Task3:");
  LCD_SetPos(0,3);
  LCD_String("Task4:");
  dt1.del = 300; dt1.num_task = 1;
  dt2.del = 400; dt2.num_task = 2;
  dt3.del = 500; dt3.num_task = 3;
  dt4.del = 600; dt4.num_task = 4;
  xQueue = xQueueCreate(10, sizeof(qData));
  xTaskCreate(vRecvTask, "vRecvTask", 256, NULL, 2, NULL);
  xTaskCreate(task1, "task1", 256,  (void *) &dt1, 1, NULL);
  xTaskCreate(task1, "task2", 256,  (void *) &dt2, 1, NULL);
  xTaskCreate(task1, "task3", 256,  (void *) &dt3, 1, NULL);
  xTaskCreate(task1, "task4", 256,  (void *) &dt4, 1, NULL);
}
//------------------------------------------------------
